#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "remoteerror4xi.py">
#<abstract4xi abstract = "provides RemoteError4Xi class"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'RemoteError4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import threading
    import array
    import queue         
except:
    pass
try:                 # rare ones
    from traceback import format_exc 
    import copyreg            
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import RemoteError
except:
    print("remoteerror4xi.py *** failed in from multiprocessing.managers import RemoteError ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>



# =================================================================================================
#<class4xi class = "RemoteError4Xi" base = "Exception" child = "None" synopsis = "provides services to remote errors" usage = "
#     managers.py 
#         __init:
#             self._Client = listener_client[serializer][1]
#
#         connect(self):
#             Listener, Client = listener_client[self._serializer]
#             conn = Client(self._address, self._authkey)
#             dispatch(conn, None, 'dummy')
#
#         dispatch(c, id, methodname, args=(), kwds={}
#             kind, result = c.recv()
#             raise convert_to_error(kind, result)                             
#
#         convert_to_error(kind, result):
#             return  RemoteError(result)
#
# convert_to_error4xi.py:
#     return  RemoteError4Xi(result)
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================

class RemoteError4Xi(Exception):
    '''
    RemoteError4Xi class provides services to remote errors
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-RemoteError4Xi" usage = "initialiazes RemoteError4Xi">                              
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
        '''
        RemoteError4Xi method __init__ initialiazes RemoteError4Xi  
        '''
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------    
           
        class2print = "RemoteError4Xi"
        method2print = "__init__"
        
        message2print = "{started" + "; init-of-RemoteError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        message2print = "{borning" + "; remoteerror2xi-of-RemoteError4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
                
                     
                        
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------    
             
        message2print = "{activated" + "; remoteerror2xi-of-RemoteError4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                 
                 
        message2print = "{returning" + "; init-of-RemoteError4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                        
        
        
                            
    #</methodize4xi>
            
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "str-of-RemoteError4Xi" usage = "returns remote error">                          
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __str__(self):
        '''
        RemoteError4Xi method __str__ method returns remote error 
        '''
             
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------    
        class2print = "RemoteError4Xi"
        method2print = "__str__"
        
        message2print = "{started" + "; str-of-RemoteError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
                   
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------    
        
        r2xi = ('\n' + '-'*75 + '\n' +  '\n *** Remote Error from Dragon4Xi: ' + str(self.args) + '\n' + '-'*75)
        
        message2print = "{returning" + "; r2xi-returning-by-str-of-RemoteError4Xi: " + str(r2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                   
        
        return r2xi
    #</methodize4xi>
    
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-RemoteError4Xi" usage = "senses RemoteError4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses RemoteError4Xi class objects
        '''
        
        
        class2print = 'RemoteError4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-RemoteError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; remoteerror4xi-sensing-by-sense-of-RemoteError4Xi: " + str(RemoteError4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-RemoteError4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        
        
      
        message2print = "{sensed" + "; remoteerror4xi-sensed-by-sense-of-RemoteError4Xi: " + str(RemoteError4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-RemoteError4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-RemoteError4Xi" usage = "reasons RemoteError4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons RemoteError4Xi class objects
        '''
         
        
        class2print = 'RemoteError4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-RemoteError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; remoteerror4xi-reasoning-by-reason-of-RemoteError4Xi: " + str(RemoteError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-RemoteError4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; remoteerror4xi-reasoned-by-reason-of-RemoteError4Xi: " + str(RemoteError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-RemoteError4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-RemoteError4Xi" usage = "aces RemoteError4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces RemoteError4Xi class objects 
        '''
           
        
        
        class2print = 'RemoteError4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-RemoteError4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
             
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; remoteerror4xi-acing-by-ace-of-RemoteError4Xi: " + str(RemoteError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-RemoteError4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; remoteerror4xi-aced-by-ace-of-RemoteError4Xi: " + str(RemoteError4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-RemoteError4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of remoteerror4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

 